summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorAlper Nebi Yasak <alpernebiyasak@gmail.com>2022-08-26 13:27:23 +0300
committerAlper Nebi Yasak <alpernebiyasak@gmail.com>2022-08-28 13:09:52 +0300
commit1dc05e4066c4984df4a16e17177cb0e4b26bab7b (patch)
tree7202b6145f69368ac6c27e88d4d51d6a4f5ec84b
parentcf295741650aaffcb03866ab15a0c7175c3dc882 (diff)
build/payload: Add helper script to build U-Boot as payload
This enables building U-Boot for boards which have config files in resources/u-boot, and copying built files that could be usable to make coreboot payloads. Right now, there is no such board in this repo. The most important file here is "u-boot.elf", which is a combination of the U-Boot binary and the appropriate device-tree file for the board. Building this needs CONFIG_REMAKE_ELF=y on the U-Boot part, and using this with CONFIG_PAYLOAD_ELF=y on the coreboot build works fine. Note that this isn't enough to make U-Boot-only releases, since low-level prerequisites like arm-trusted-firmware aren't passed in to the U-Boot build system. Coreboot builds its own copy of TF-A and sets it up on the board, so using these U-Boot builds as payloads should still work. Signed-off-by: Alper Nebi Yasak <alpernebiyasak@gmail.com>
-rwxr-xr-xresources/scripts/build/payload/u-boot146
1 files changed, 146 insertions, 0 deletions
diff --git a/resources/scripts/build/payload/u-boot b/resources/scripts/build/payload/u-boot
new file mode 100755
index 00000000..6c94a441
--- /dev/null
+++ b/resources/scripts/build/payload/u-boot
@@ -0,0 +1,146 @@
+#!/usr/bin/env bash
+
+# helper script: builds U-Boot source code
+#
+# Copyright (C) 2020, 2021 Leah Rowe <info@minifree.org>
+# Copyright (C) 2021 Vitali64 <vitali64pmemail@protonmail.com>
+# Copyright (C) 2022 Alper Nebi Yasak <alpernebiyasak@gmail.com>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+[ "x${DEBUG+set}" = 'xset' ] && set -v
+set -u -e
+
+RET=0
+
+# Build U-Boot
+# ---------------------------------------------------------------------
+
+printf "Building U-Boot payloads\n"
+
+# Build for all boards if no argument is given
+if [ "$#" -eq 0 ]; then
+ for board_dir in resources/u-boot/*; do
+ if [ -d "${board_dir}/config/" ]; then
+ set -- "$@" "${board_dir#resources/u-boot/}"
+ fi
+ done
+fi
+
+[ ! -d "payload/" ] && mkdir -p payload/
+[ ! -d "payload/u-boot" ] && mkdir -p payload/u-boot/
+
+# Appends additional version info to U-Boot
+our_version="$(cat version)"
+projectname="$(cat projectname)"
+export LOCALVERSION="-${projectname}-${our_version}"
+
+for board in "$@"; do
+ board_dir="resources/u-boot/${board}"
+ rm -rf "payload/u-boot/${board}"
+ mkdir -p "payload/u-boot/${board}"
+
+ ubtree="undefined"
+ arch="undefined"
+
+ if [ ! -f "${board_dir}/board.cfg" ]; then
+ printf "%s: Target %s does not have a board.cfg. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ # Override the above defaults using board.cfg
+ source "${board_dir}/board.cfg"
+
+ if [ "${ubtree}" = "undefined" ]; then
+ printf "%s: Target %s does not define a U-Boot tree. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+ if [ "${arch}" = "undefined" ]; then
+ printf "%s: Target %s does not define a CPU type. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ ubdir="u-boot/${board}"
+ if [ "${board}" != "${ubtree}" ]; then
+ ubdir="u-boot/${ubtree}"
+ fi
+
+ if [ ! -d "${ubdir}" ]; then
+ ./download u-boot "$board"
+ fi
+
+ if [ ! -d "${ubdir}" ]; then
+ printf "%s: Failed to download U-Boot for target %s. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ if [ "${arch}" = "x86_32" ] || [ "${arch}" = "x86_64" ]; then
+ export CROSS_COMPILE=x86_64-linux-
+ elif [ "${arch}" = "ARMv7" ]; then
+ export CROSS_COMPILE=arm-linux-gnueabi-
+ elif [ "${arch}" = "AArch64" ]; then
+ export CROSS_COMPILE=aarch64-linux-gnu-
+ fi
+
+ for config in "${board_dir}/config"/*; do
+ if [ ! -f "${config}" ]; then
+ printf "%s: Target %s has no configs to build for. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ config_name="${config#$board_dir/config/}"
+ if [ "$config_name" = "default" ]; then
+ dest_dir="payload/u-boot/${board}"
+ else
+ dest_dir="payload/u-boot/${board}/${config_name}"
+ fi
+ mkdir -p "${dest_dir}"
+
+ printf "%s: Building for target %s (config %s).\n" \
+ "build/payload/u-boot" "${board}" "${config_name}"
+
+ make -C "${ubdir}" distclean
+
+ cp "${config}" "${ubdir}/.config"
+ make -C "${ubdir}" olddefconfig
+ make -C "${ubdir}" -j"$(nproc)" all
+
+ for f in "${ubdir}"/u-boot{,.bin,.dtb,.img,.itb,.elf}; do
+ if [ -f "$f" ]; then
+ mv "$f" "${dest_dir}/"
+ fi
+ done
+
+ make -C "${ubdir}" distclean
+
+ printf "%s: Built for target %s (config %s).\n" \
+ "build/payload/u-boot" "${board}" "${config_name}"
+ done
+done
+
+printf "Done! U-Boot files are in payload/u-boot/\n\n"
+exit $RET
+
+# ------------------- DONE ----------------------